import java.util.*;


public class Player {
	Random r = new Random();
	boolean AI = false;
	int playerId; // Gewoon het nummer van de speler.
	AgentKnowledge AK[];
	
	
	Player(boolean thinking, int pId, CommonKnowledge CK) {
		AI = thinking;
		playerId= pId;
		AK = new AgentKnowledge[CK.nPlayers];
		
		for (int i=0; i<CK.nPlayers; i++) {
			AK[i] = new AgentKnowledge(CK.nFamilies, CK.nGenerations, i);
		}	
	}

	
	public boolean questionFamilyFirstOrder(CommonKnowledge CK, Player listener1, Player listener2) {
		int player1, player2, choice;
		
		player1 = r.nextInt(CK.nPlayers);
		do {
			player2 = r.nextInt(CK.nPlayers);
		} while (player1 == player2);
		
		//AK[playerId].updateWithCommonKnowledge(CK.shot);
		AK[playerId].createPossibleBeliefs();
		
		
		System.out.println("- Are agent " + player1 + " and agent " + player2 + " in the same family?");
		/*try {
			Thread.currentThread().sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
		
		if (AI) {
			choice = 0;
			
			Iterator itr = AK[playerId].cBelief.iterator();
			while (itr.hasNext()) {
				ArrayList<Integer> current = (ArrayList<Integer>) itr.next();
				if (current.contains(player1) && current.contains(player2))
					choice = 1;
			}
			
			if (choice==1)
				System.out.print("I think they are. My belief state is: ");
			else
				System.out.print("Most definitely not. My belief state is: ");
			
			AK[playerId].printBelief();
			
		} else {
			choice = askHuman(0,1);
		}
	
		boolean sameTeam = (CK.family[player1]==CK.family[player2]);
		AK[playerId].updateFamily(player1, player2, sameTeam); // KplayerId Phi
		
		listener1.AK[listener1.playerId].updateFamily(player1, player2, sameTeam); // Klistener1 Phi
		listener1.AK[playerId].updateFamily(player1, player2, sameTeam); // Klistener1 KplayerID Phi
		
		listener2.AK[listener2.playerId].updateFamily(player1, player2, sameTeam); // Klistener2 Phi
		listener1.AK[playerId].updateFamily(player1, player2, sameTeam);// Klistener2 KplayerID Phi
		
		System.out.println("- Agent " + listener1.playerId + " and agent " + listener2.playerId + " secretly eavesdropped the question and answer.");
		
		return sameTeam==(choice==1); // Super vies! Maar eigenlijk best netjes.
	}
	
	public boolean questionGenerationFirstOrder(CommonKnowledge CK, Player listener1, Player listener2) {
		int player1, player2, choice;
		
		player1 = r.nextInt(CK.nPlayers);
		do {
			player2 = r.nextInt(CK.nPlayers);
		} while (player1 == player2);
		
		AK[playerId].createPossibleBeliefs();
		System.out.println("- Is agent " + player1 + " younger/same age/older than agent " + player2 + "?");

		/*try {
			Thread.currentThread().sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
		
		if (AI) {
			choice = 1;
			int iOf1 = -1, iOf2 = -1;
			
			Iterator itr = AK[playerId].cBelief.iterator();
			while(itr.hasNext()) {
				ArrayList <Integer> current = (ArrayList<Integer>) itr.next();
				if (iOf1 == -1)
					iOf1 = current.indexOf(player1);
				
				if (iOf2 == -1)
					iOf2 = current.indexOf(player2);
			}
			
			if (iOf1>iOf2) choice = 2;
			if (iOf1<iOf2) choice = 0;
		} else {
			choice = askHuman(0,2);
		}
		
		int goodAnswer = 1;
		if (CK.generation[player1]>CK.generation[player2]) goodAnswer = 2;
		if (CK.generation[player1]<CK.generation[player2]) goodAnswer = 0;
		
		switch (choice) {
		case 0:
			System.out.print("Agent " + player1 + " is younger than agent " + player2 + " according to my belief: ");
			break;
		case 1:
			System.out.print("Agent " + player1 + " is the same age as agent " + player2 + " according to my belief: ");
			break;
		case 2:
			System.out.print("Agent " + player1 + " is older than agent " + player2 + " according to my belief: ");
			break;
		}
		
		AK[playerId].printBelief();
		
		switch (goodAnswer) {
		case 0:
			System.out.println("- The truth is that agent " + player1 + " is younger than agent " + player2 + ".");
			break;
		case 1:
			System.out.println("- The truth is that agent " + player1 + " is the same age as agent " + player2 + ".");
			break;
		case 2:
			System.out.println("- The truth is that agent " + player1 + " is older than agent " + player2 + ".");
			break;
		}
		
		AK[playerId].updateGeneration(player1, player2, goodAnswer); // KplayerId Phi
		
		listener1.AK[listener1.playerId].updateGeneration(player1, player2, goodAnswer); // Klistener1 Phi
		listener1.AK[playerId].updateGeneration(player1, player2, goodAnswer); // Klistener1 KplayerID Phi
		
		listener1.AK[listener1.playerId].updateGeneration(player1, player2, goodAnswer); // Klistener2 Phi
		listener1.AK[playerId].updateGeneration(player1, player2, goodAnswer); // Klistener2 KplayerID Phi
		
		System.out.println("- Agent " + listener1.playerId + " and agent " + listener2.playerId + " secretly eavesdropped the question and answer.");

		
		return choice==goodAnswer; // Super vies! Maar eigenlijk best netjes.
	}
	
	public boolean questionFamilySecondOrder(CommonKnowledge CK, Player listener1, Player listener2) {
		int player1, player2, choice = 0;
		double pMe=0, pListener1=0, pListener2=0;
		boolean skipCalc=false;
		
		player1 = r.nextInt(CK.nPlayers);
		do {
			player2 = r.nextInt(CK.nPlayers);
		} while (player1 == player2);
		
		System.out.println("- Second order question.");
		System.out.println("- Are agent " + player1 + " and agent " + player2 + " are in the same family?");
		System.out.println("- Who will give the wrong answer? Choose between agent " + listener1.playerId + " and agent " + listener2.playerId + ".");

		pMe = AK[playerId].familyAnswer(player1, player2);
		pListener1 = AK[listener1.playerId].familyAnswer(player1, player2);
		pListener2 = AK[listener2.playerId].familyAnswer(player1, player2);
		
		Iterator itr;
		if (Math.round(pMe)==1) {
			System.out.println("I think they are is the same group.");
			if (pListener1==0.0 && pListener2==0.0) {
				System.out.println("And I think they both know they are in the same group. So I will take a pass.");
				itr = listener2.AK[playerId].cBelief.iterator();// niet gebruikt
				skipCalc=true;
			} else if (pListener1>pListener2) {	
				System.out.println("And counting the relations of agent " + listener2.playerId + "'s kripke states I think he does not know. (" + pListener2 + ").");
				itr = listener2.AK[playerId].cBelief.iterator();
			} else {
				System.out.println("And counting the relations of agent " + listener1.playerId + "'s kripke states I think he does not know. (" + pListener1 + ").");
				itr = listener1.AK[playerId].cBelief.iterator();
			}
		} else {
			System.out.println("I think they are not is the same group.");
			
			if (pListener1==0.0 && pListener2==0.0) {
				System.out.println("And I think they both know they are not in the same group. So I will take a pass.");
				itr = listener2.AK[playerId].cBelief.iterator();// niet gebruikt
				skipCalc=true;
			} else if (pListener1<pListener2) {	
				System.out.println("And counting the relations of agent " + listener2.playerId + "'s kripke states I think he does not know. (" + pListener2 + ").");
				itr = listener2.AK[playerId].cBelief.iterator();
			} else {
				System.out.println("And counting the relations of agent " + listener1.playerId + "'s kripke states I think he does not know. (" + pListener1 + ").");
				itr = listener1.AK[playerId].cBelief.iterator();
			}
		}
		

		if (!skipCalc) {
			while (itr.hasNext()) {
				ArrayList<Integer> current = (ArrayList<Integer>) itr.next();
				if (current.contains(player1) && current.contains(player2))
				choice = 1;
			}
		} else {
			return true;
		}
		if (choice==1)
			System.out.println("We hear the agent responding: I think they are in the same group!");
		else
			System.out.println("We hear the agent responding: No they are not in the same group!");
		
		return (CK.family[player1]==CK.family[player2])==(choice==0) ;
	}
	
	public int askHuman(int min, int max) {
		int choice;
		Scanner in = new Scanner(System.in);
		do {
			try {
				choice = in.nextInt();
			} catch (Exception e) {
				choice = -1;
			}
		} while (choice < min || choice > max);
		
		return choice;
	}
}
